﻿/**********************************************************************************************************************
* Gaia Framework for Adobe Flash �2007
* Written by: Steven Sacks
* email: stevensacks@gmail.com
* blog: http://www.stevensacks.net/
* forum: http://www.gaiaflashframework.com/
* By using the Gaia Framework, you agree to keep the above contact information in the source code.

Distributed under Creative Commons Attribution-ShareAlike 3.0 Unported License
http://creativecommons.org/licenses/by-sa/3.0/

THE WORK (AS DEFINED BELOW) IS PROVIDED UNDER THE TERMS OF THIS CREATIVE COMMONS PUBLIC LICENSE ("CCPL" OR "LICENSE"). 
THE WORK IS PROTECTED BY COPYRIGHT AND/OR OTHER APPLICABLE LAW. ANY USE OF THE WORK OTHER THAN AS AUTHORIZED UNDER THIS 
LICENSE OR COPYRIGHT LAW IS PROHIBITED.

BY EXERCISING ANY RIGHTS TO THE WORK PROVIDED HERE, YOU ACCEPT AND AGREE TO BE BOUND BY THE TERMS OF THIS LICENSE. 
TO THE EXTENT THIS LICENSE MAY BE CONSIDERED TO BE A CONTRACT, THE LICENSOR GRANTS YOU THE RIGHTS CONTAINED HERE IN 
CONSIDERATION OF YOUR ACCEPTANCE OF SUCH TERMS AND CONDITIONS.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO
THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
**********************************************************************************************************************/

import net.stevensacks.utils.ObservableClass;
import com.gaiaframework.assets.AbstractAsset;
import com.gaiaframework.core.Preloader;
import mx.utils.Delegate;

class com.gaiaframework.assets.AssetProgress extends ObservableClass
{
	private static var _instance:AssetProgress;
	
	private var assets:Object;
	private var totalAssets:Number;
	private var completeAssets:Number;
	
	private var eachPerc:Number;
	
	private var progressDelegate:Function;
	private var completeDelegate:Function;
	
	private var _preloader:MovieClip;
	private var preloaderLoadDelegate:Function;
	private var preloaderProgressDelegate:Function;
	private var preloaderCompleteDelegate:Function;
	
	private function AssetProgress()
	{
		super();
		assets = {};
		totalAssets = 0;
		completeAssets = 0;
		progressDelegate = Delegate.create(this, onProgress);
		completeDelegate = Delegate.create(this, onComplete);
	}
	public static function birth():Void
	{
		if (_instance == null) _instance = new AssetProgress();
	}
	public static function get instance():AssetProgress
	{
		return _instance;
	}
	public function set preloader(pl:Preloader):Void
	{
		this.removeEventListener("load", preloaderLoadDelegate);
		this.removeEventListener("progress", preloaderProgressDelegate);
		this.removeEventListener("complete", preloaderCompleteDelegate);
		preloaderLoadDelegate = Delegate.create(pl, pl.onStart);
		preloaderProgressDelegate = Delegate.create(pl, pl.onProgress);
		preloaderCompleteDelegate = Delegate.create(pl, pl.onComplete);
		this.addEventListener("load", preloaderLoadDelegate);
		this.addEventListener("progress", preloaderProgressDelegate);
		this.addEventListener("complete", preloaderCompleteDelegate);
	}
	public function load(asset:AbstractAsset):Void
	{
		if (!assets[asset.id])
		{
			if (totalAssets == 0) dispatchEvent({type:"load"});
			totalAssets++;
			eachPerc = 100 / totalAssets;
			assets[asset.id] = asset;
			asset.addEventListener("progress", progressDelegate);
			asset.addEventListener("complete", completeDelegate);
		}
	}
	private function onProgress(evt:Object):Void
	{
		var topPerc:Number = 0;
		var totalPerc:Number = 0;
		var topAsset:AbstractAsset = evt.asset;
		var assetPerc:Number;
		for (var a:String in assets)
		{
			assetPerc = assets[a].percentLoaded;
			if (isNaN(assetPerc)) assetPerc = 0;
			if (assetPerc != 1 && assetPerc > topPerc)
			{
				topPerc = assetPerc;
				topAsset = assets[a];
			}
			totalPerc += (assetPerc * eachPerc);
		}
		dispatchEvent({type:"progress", perc:totalPerc, asset:topAsset, totalFiles:totalAssets});
	}
	private function onComplete(evt:Object):Void
	{
		var asset:AbstractAsset = evt.asset;
		asset.removeEventListener("progress", progressDelegate);
		asset.removeEventListener("complete", completeDelegate);
		if (++completeAssets == totalAssets)
		{
			assets = {};
			completeAssets = 0;
			totalAssets = 0;
			dispatchEvent({type:"complete", noDispatch:true});
		}
	}
}