﻿/**********************************************************************************************************************
* Gaia Framework for Adobe Flash �2007
* Written by: Steven Sacks
* email: stevensacks@gmail.com
* blog: http://www.stevensacks.net/
* forum: http://www.gaiaflashframework.com/
* By using the Gaia Framework, you agree to keep the above contact information in the source code.

Distributed under Creative Commons Attribution-ShareAlike 3.0 Unported License
http://creativecommons.org/licenses/by-sa/3.0/

THE WORK (AS DEFINED BELOW) IS PROVIDED UNDER THE TERMS OF THIS CREATIVE COMMONS PUBLIC LICENSE ("CCPL" OR "LICENSE"). 
THE WORK IS PROTECTED BY COPYRIGHT AND/OR OTHER APPLICABLE LAW. ANY USE OF THE WORK OTHER THAN AS AUTHORIZED UNDER THIS 
LICENSE OR COPYRIGHT LAW IS PROHIBITED.

BY EXERCISING ANY RIGHTS TO THE WORK PROVIDED HERE, YOU ACCEPT AND AGREE TO BE BOUND BY THE TERMS OF THIS LICENSE. 
TO THE EXTENT THIS LICENSE MAY BE CONSIDERED TO BE A CONTRACT, THE LICENSOR GRANTS YOU THE RIGHTS CONTAINED HERE IN 
CONSIDERATION OF YOUR ACCEPTANCE OF SUCH TERMS AND CONDITIONS.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO
THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
**********************************************************************************************************************/

import com.gaiaframework.assets.AssetProgress;
import com.gaiaframework.assets.SoundAsset;
import mx.utils.Delegate;

class com.gaiaframework.assets.SoundClipAsset extends SoundAsset
{		
	private var checkLoadInterval:Number;
	
	function SoundClipAsset()
	{
		super();
		_clip = null;
	}
	public function get sound():Sound
	{
		return _clip.sound;
	}
	public function init(target:MovieClip):Void
	{
		isActive = true;
		_clip = target;
	}
	public function preload():Void
	{
		_clip.loadMovie(src);
		super.load();
	}
	public function load(secondOffset:Number, loops:Number):Void
	{
		if (percentLoaded == 1)
		{
			start(secondOffset, loops);
		}
		else
		{
			clearInterval(checkLoadInterval);
			checkLoadInterval = setInterval(this, "checkSoundLoaded", 30);
			if (showProgress) AssetProgress.instance.load(this);
			_secondOffset = secondOffset;
			_loops = loops;
			_clip.loadMovie(src);
			super.abstract.load();
		}
	}
	private function checkSoundLoaded():Void
	{
		if (percentLoaded == 1 && sound != undefined)
		{
			clearInterval(checkLoadInterval);
			sound.start(_secondOffset, _loops);
			_secondOffset = 0;
		}
	}
	public function getBytesLoaded():Number
	{
		return _clip.getBytesLoaded();
	}
	public function getBytesTotal():Number
	{
		return _clip.getBytesTotal();
	}
	public function retry():Void
	{
		_clip.loadMovie(src);
	}
	// SOUND GROUP PRELOAD
	public function soundGroupPreload(secondOffset:Number, loops:Number):Void
	{
		sound.stop();
		_secondOffset = secondOffset;
		_loops = loops;
		if (showProgress) AssetProgress.instance.load(this);
		_clip.loadMovie(src);
		super.abstract.load();
	}
}