﻿/**********************************************************************************************************************
* Gaia Framework for Adobe Flash �2007
* Written by: Steven Sacks
* email: stevensacks@gmail.com
* blog: http://www.stevensacks.net/
* forum: http://www.gaiaflashframework.com/
* By using the Gaia Framework, you agree to keep the above contact information in the source code.

Distributed under Creative Commons Attribution-ShareAlike 3.0 Unported License
http://creativecommons.org/licenses/by-sa/3.0/

THE WORK (AS DEFINED BELOW) IS PROVIDED UNDER THE TERMS OF THIS CREATIVE COMMONS PUBLIC LICENSE ("CCPL" OR "LICENSE"). 
THE WORK IS PROTECTED BY COPYRIGHT AND/OR OTHER APPLICABLE LAW. ANY USE OF THE WORK OTHER THAN AS AUTHORIZED UNDER THIS 
LICENSE OR COPYRIGHT LAW IS PROHIBITED.

BY EXERCISING ANY RIGHTS TO THE WORK PROVIDED HERE, YOU ACCEPT AND AGREE TO BE BOUND BY THE TERMS OF THIS LICENSE. 
TO THE EXTENT THIS LICENSE MAY BE CONSIDERED TO BE A CONTRACT, THE LICENSOR GRANTS YOU THE RIGHTS CONTAINED HERE IN 
CONSIDERATION OF YOUR ACCEPTANCE OF SUCH TERMS AND CONDITIONS.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO
THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
**********************************************************************************************************************/

import net.stevensacks.utils.ObservableClass;
import com.gaiaframework.assets.PageAsset;
import com.gaiaframework.core.BranchTools;
import com.gaiaframework.core.SiteModel;
import com.asual.SWFAddressEvent;
import com.asual.SWFAddress;
import mx.utils.Delegate;

// This class implements the SWFAddress Class v2.0 written by Rostislav Hristov
// More info: http://www.asual.com/SWFAddress/

class com.gaiaframework.core.GaiaSWFAddress extends ObservableClass
{
	private static var _deeplink:String = "";	
	private var _value:String = "/";	
	private var isInternal:Boolean = false;
	
	private static var _instance:GaiaSWFAddress;
	
	private function GaiaSWFAddress() 
	{
		super();
	}
	public static function birth():Void
	{
		if (_instance == null) _instance = new GaiaSWFAddress();
	}
	public static function get instance():GaiaSWFAddress
	{
		return _instance;
	}
	public static function get deeplink():String
	{
		return _deeplink;
	}	
	public function init():Void 
	{
		SWFAddress.addEventListener(SWFAddressEvent.CHANGE, Delegate.create(this, onChange));
		if (!SiteModel.history) SWFAddress.setHistory(false);
		var v:String = SWFAddress.getValue();
		if (v == "null") v = (insertStrictSlashes(_root.deeplink) || "/");
		if (v != "/") SWFAddress.setValue(v);
	}
	public function onGoto(evt:Object):Void
	{
		if (!evt.external && _value != evt.fullBranch)
		{
			isInternal = true;
			var strictString:String;
			if (SiteModel.routing)
			{
				_deeplink = evt.fullBranch.substring(evt.validBranch.length, evt.fullBranch.length);
				strictString = insertStrictSlashes(BranchTools.getPage(evt.validBranch).route + _deeplink);
			}
			else
			{
				strictString = insertStrictSlashes(evt.fullBranch.split("/").slice(1).join("/"));
			}
			SWFAddress.setValue(strictString);
			if (SiteModel.title.length > 0) SWFAddress.setTitle(SiteModel.title.split("%PAGE%").join(BranchTools.getPage(evt.validBranch).title));
			isInternal = false;
		}
	}
	public function onChange(event:SWFAddressEvent):Void 
	{
		_value = stripStrictSlashes(event.value);
		dispatchDeeplink();
		if (!isInternal)
		{
			if (_value.length > 1) 
			{
				if (SiteModel.routing)
				{
					var validRoute:String = validate(_value);
					if (validRoute.length > 0) dispatchGoto(SiteModel.routes[validRoute] + _deeplink);
				}
				else 
				{
					var validBranch:String = validate(_value);
					dispatchGoto(validBranch);
				}
			} 
			else 
			{
				dispatchGoto("index");
			}
		}
	}
	private function dispatchGoto(branch:String):Void
	{
		dispatchEvent({type:"goto", branch:branch});
	}
	private function dispatchDeeplink():Void 
	{
		_deeplink = "";
		var validated:String = validate(_value);
		if (validated.length > 0) _deeplink = _value.substring(validated.length, _value.length);
		if (_deeplink.length > 0) _global.tt("deeplink", _deeplink);
		dispatchEvent({type:"deeplink", deeplink:_deeplink});
	}
	private function validate(str:String):String
	{
		var val:String = stripStrictSlashes(str);
		if (SiteModel.routing)
		{
			return BranchTools.getValidRoute(val);
		}
		else
		{
			return BranchTools.getFullBranch(val).split("/").slice(1).join("/");
		}
	}
	private function stripStrictSlashes(str:String):String
	{
		if (str == undefined || str.length == 0) return "";
		if (str.charAt(0) == "/") str = str.substr(1);
		if (str.charAt(str.length - 1) == "/") str = str.substr(0, str.length - 1);
		return str;
	}
	private function insertStrictSlashes(str:String):String
	{
		if (str == undefined || str.length == 0) return "/";
		if (str.charAt(0) != "/") str = "/" + str;
		if (str.charAt(str.length - 1) != "/") str = str + "/";
		return str;
	}
}