import net.stevensacks.utils.ObservableClip;
import mx.transitions.easing.Regular;
import mx.transitions.Tween;
import mx.utils.Delegate;

class us.mojocosmetics.allies.MapView extends ObservableClip
{
	private var statesArray:Array = ["Alabama", "Alaska", "Arizona", "Arkansas", "California", "Colorado", "Connecticut", "Delaware", "Florida", "Georgia", "Hawaii", "Idaho", "Illinois", "Indiana", "Iowa", "Kansas", "Kentucky", "Louisiana", "Maine", "Maryland", "Massachusetts", "Michigan", "Minnesota", "Mississippi", "Missouri", "Montana", "Nebraska", "Nevada", "New_Hampshire", "New_Jersey", "New_Mexico", "New_York", "North_Carolina", "North_Dakota", "Ohio", "Oklahoma", "Oregon", "Pennsylvania", "Rhode_Island", "South_Carolina", "South_Dakota", "Tennessee", "Texas", "Utah", "Vermont", "Virginia", "Washington", "Washington_DC", "West_Virginia", "Wisconsin", "Wyoming"];
	private var currentState:String = "California";
	private var statesData:Object;
	
	private var MC_Stick:MovieClip;
	private var offsetX:Number = -99;
	private var offsetY:Number = 89;
	
	private var BTN_HQ:MovieClip;
	private var BTN_Ring:MovieClip;
	
	private var MC_Stores:MovieClip;
	private var MC_Quotes:MovieClip;
	private var MC_MapRoll:MovieClip;
	
	private var MC_Movie:MovieClip;
	private var BTN_Block:MovieClip;
	
	private var speed:Number = 1250;
	private var mapTween:Tween;
	
	function MapView()
	{
		super();
		MC_MapRoll = this._parent.MC_MapRoll;
	}
	private function init():Void
	{
		BTN_Ring.onPress = Delegate.create(this, pressRing);
		BTN_Ring.onRelease = BTN_Ring.onReleaseOutside = Delegate.create(this, releaseRing);
	}
	private function configUI():Void
	{
		Mouse.hide();
		BTN_Block._visible = false;
		BTN_Block.useHandCursor = false;
		BTN_Block.onRelease = null;
		this.setMask(null);
		BTN_HQ.onRollOver = Delegate.create(this, rolloverHQ);
		BTN_HQ.onRollOut = Delegate.create(this, rolloutHQ);
		BTN_HQ.onRelease = Delegate.create(this, clickHQ);
		BTN_HQ.useHandCursor = false;
		MC_Stick = this._parent.MC_Stick;
		MC_Stick._visible = true;
		MC_Stick.MAPVIEW = this;
		tweenStickToMouse();
		initStates();
	}
	
	private function pressRing():Void
	{
		BTN_Ring.gotoAndStop("pressed");
		this.startDrag(false, -54, -603, -54, -27);
		this.onEnterFrame = Delegate.create(this, mapDrag);
	}
	private function releaseRing():Void
	{
		stopDrag();
		BTN_Ring.enabled = false;
		if (this._y < -29) 
		{
			var duration:Number = Math.round(speed * (1 - (this._y + 603) / 576)) / 1000;
			mapTween = new Tween(this, "_y", Regular.easeOut, this._y, -27, duration, true);
			mapTween.onMotionFinished = Delegate.create(this, onTweenFinished);
		}
		else
		{
			onTweenFinished();
		}
	}
	private function onTweenFinished():Void
	{
		this._y = -27;
		MC_MapRoll.goPerc(1);
		gotoAndStop(2);
		delete this.onEnterFrame;
		delete mapTween;
	}
	
	private function mapDrag():Void
	{
		var y:Number = this._y + 603;
		MC_MapRoll.goPerc(y / 576); 
	}
	private function rolloverHQ():Void
	{
		BTN_HQ.gotoAndPlay("in");
	}
	private function rolloutHQ():Void
	{
		BTN_HQ.gotoAndPlay("out");
	}
	private function clickHQ():Void
	{
		delete MC_Stick.onEnterFrame;
		MC_Stick._visible = false;
		Mouse.show();
		BTN_Block._visible = true;
		MC_Movie.gotoAndStop(2);
	}
	private function activateStick():Void
	{
		MC_Stick.onEnterFrame = Delegate.create(this, updateStickPosition);
		BTN_Block._visible = false;
	}
	private function updateStickPosition():Void
	{
		MC_Stick._x = _xmouse + offsetX;
		MC_Stick._y = _ymouse + offsetY;
		if ((MC_Stick._x > 800 && MC_Stick._y > 445) || MC_Stick._y > 710)
		{
			if (MC_Stick._visible)
			{
				MC_Stick._visible = false;
				Mouse.show();
			}
		}
		else
		{
			if (!MC_Stick._visible)
			{
				MC_Stick._visible = true;
				Mouse.hide();
			}
		}
	}
	private function tweenStickToMouse():Void
	{
		MC_Stick.tweenX.stop();
		MC_Stick.tweenY.stop();
		MC_Stick.tweenX = new Tween(MC_Stick, "_x", Regular.easeOut, MC_Stick._x, (_xmouse + offsetX), 6, false);
		MC_Stick.tweenY = new Tween(MC_Stick, "_y", Regular.easeOut, MC_Stick._y, (_ymouse + offsetY), 6, false);
		MC_Stick.tweenY.onMotionFinished = Delegate.create(this, activateStick);
	}
	
	private function rolloverState(state:MovieClip)
	{
		currentState = state._name.substr(4);
		MC_Stick.updateState(currentState.split("_").join(" "));
	}
	private function pressState()
	{
		delete MC_Stick.onEnterFrame;
		MC_Stick._x = _xmouse + offsetX;
		MC_Stick._y = _ymouse + offsetY;
		MC_Stick.gotoAndPlay("in");
		MC_Stores.update(currentState.split("_").join(" "), statesData[currentState]);
	}
	function releaseState()
	{	
		MC_Stick.gotoAndPlay("out");
	}
	function initStates()
	{
		var ref:MapView = this;
		var i:Number = statesArray.length;
		while (i--)
		{
			this["BTN_" + statesArray[i]].onRollOver = function()
			{
				ref.rolloverState(this);
			};
			this["BTN_" + statesArray[i]].onPress = function()
			{
				ref.pressState();
			};
			this["BTN_" + statesArray[i]].onRelease = this["BTN_" + statesArray[i]].onReleaseOutside = function()
			{
				ref.releaseState();
			};
			this["BTN_" + statesArray[i]].useHandCursor = false;
		}
	}
}