import com.gaiaframework.utils.AssetFilter;
import com.gaiaframework.utils.SoundGroup;
import mx.utils.Delegate;

class us.mojocosmetics.nav.Radio extends MovieClip
{
	private var normal:Object;
	private var military:Object;
	
	private var normalSG:SoundGroup;
	private var militarySG:SoundGroup;
	
	private var nextDelegate:Function;
	private var selectDelegate:Function;
	private var startDelegate:Function;
	
	private var muted:Boolean = false;
	private var playing:Boolean = false;
	private var mode:String;
	
	private var _clip:MovieClip;
	private var MC_Notes:MovieClip;
	private var BTN_Radio:MovieClip;
	
	function Radio(mc:MovieClip)
	{
		_clip = mc;
		_global.gIsMuted = muted;
		MC_Notes = _clip.MC_Notes;
		BTN_Radio = _clip.BTN_Radio;
		BTN_Radio.onRelease = Delegate.create(this, toggleRadio);
		//
		normal = {};
		military = {};
		//
		var music:Object = AssetFilter.getSound(_global.Gaia.getPage("index").assets);
		nextDelegate = Delegate.create(this, playNextSong);
		selectDelegate = Delegate.create(this, selectMode);
		startDelegate = Delegate.create(this, startMusic);
		var a:String;
		for (a in music)
		{
			music[a].onSoundComplete = nextDelegate;
			if (a.split("_")[0] == "military")
			{
				military[a] = music[a];
			}
			else
			{
				normal[a] = music[a];
			}
		}
		normalSG = new SoundGroup(normal);
		militarySG = new SoundGroup(military);
		_global.Gaia.afterComplete(Delegate.create(this, init), false, true);
		startMusic({validBranch:_global.Gaia.getCurrentBranch()});
	}
	private function init(evt:Object):Void
	{
		_global.Gaia.afterTransitionOut(selectDelegate);
		_global.Gaia.beforeTransitionIn(startDelegate);
	}
	
	private function toggleRadio():Void
	{
		if (muted)
		{
			muted = false;
			startMusic({validBranch:_global.Gaia.getCurrentBranch()});
			MC_Notes.gotoAndPlay(2);
		}
		else
		{
			muted = true;
			stopMusic();
			MC_Notes.gotoAndStop(1);
		}
		_global.gIsMuted = muted;
	}

	private function startMusic(evt:Object):Void
	{
		if (!muted && !playing)
		{
			var sg:SoundGroup;
			if (evt.validBranch == "index/propaganda" || evt.validBranch == "index/headquarters")
			{
				sg = militarySG;
				mode = "military";
			}
			else
			{
				sg = normalSG;
				mode = "normal";
			}
			sg.setVolume(0);
			sg.fadeTo(60, 150);
			playing = true;
			MC_Notes.gotoAndPlay(2);
			_global.gNewsieDance(true);
			playNextSong();
		}
	}
	private function stopMusic():Void
	{
		muted = true;
		playing = false;
		MC_Notes.gotoAndStop(1);
		_global.gNewsieDance(false);
		//
		if (mode == "normal")
		{
			fadeOutNormal();
		}
		else
		{
			fadeOutMilitary();
		}
		_global.gIsMuted = muted;
	}
	private function playNextSong():Void
	{
		if (!muted)
		{
			if (mode == "normal")
			{
				normalSG.playRandom();
			}
			else
			{
				militarySG.playRandom();
			}
		}
	}
	private function fadeNormalComplete():Void
	{
		normalSG.stop();
	}
	private function fadeMilitaryComplete():Void
	{
		militarySG.stop();
	}
	private function selectMode(evt:Object):Void
	{
		if (evt.validBranch == "index/propaganda" || evt.validBranch == "index/headquarters")
		{
			if (mode == "normal" && !muted) 
			{
				fadeOutNormal();
				playing = false;
			}
			mode = "military";
		}
		else
		{
			if (mode == "military" && !muted)
			{
				fadeOutMilitary();
				playing = false;
			}
			mode = "normal";
		}
	}
	private function fadeOutNormal():Void
	{
		normalSG.fadeTo(0, 250, Delegate.create(this, fadeNormalComplete));
	}
	private function fadeOutMilitary():Void
	{
		militarySG.fadeTo(0, 250, Delegate.create(this, fadeMilitaryComplete));
	}
}